Attribute VB_Name = "ModMain"
'//      ZxCollector By Xavier Martin. (XavSnap)
'//      -----------------------------
'// Description:
'// Collect and create a ZX81's name database,
'// in a "DAT" file supported by RomCenter.
'//

' VB App_Path leek
Private Declare Function GetShortPathNameA Lib "kernel32.dll" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Private Declare Function GetLongPathNameA Lib "kernel32.dll" (ByVal lpszShortPath As String, ByVal lpszLongPath As String, ByVal cchBuffer As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)

#If Win16 Then
Declare Function WritePrivateProfileString Lib "kernel32.dll" (ByVal AppName As String, ByVal KeyName As String, ByVal NewString As String, ByVal Filename As String) As Integer
Declare Function GetPrivateProfileString Lib "kernel32.dll" Alias "GetPrivateProfilestring" (ByVal AppName As String, ByVal KeyName As Any, ByVal default As String, ByVal ReturnedString As String, ByVal MaxSize As Integer, ByVal Filename As String) As Integer
#Else
Declare Function GetPrivateProfileString Lib "kernel32.dll" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32.dll" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Any, ByVal lpFileName As String) As Long
#End If

' // Audit Rom Center v2.5 compatibility.
Type Rom_Center
'set filename
S_FileName As String
'set full name
S_FullName As String
'clone filename
C_FileName As String
'clone full name
C_FullName As String
'rom filename
Rom_Name As String
'rom crc
Rom_CRC As String
'size
Rom_Size As Long
'merged clone name
MC_Name As String
'merged rom name
MR_Name As String
End Type

' // Rom CRC Audit type.
Public Type Files_DATAs
        File_Main_Name As String
        File_Main_Comment As String
        File_Sec_Name As String
        File_Sec_Comment As String
        File_MsName As String
        File_Crc32 As String
        File_Lenght As Long
        File_Comment As String
        File_Merge As String
End Type

Public Files_DATAs() As Files_DATAs ' Rom audit arguments.
Public lFirstLoad As Boolean
Public Exit_All As Boolean
Public Edit_Index As Long
Public bUnselect As Boolean
Public buffer() As Byte

Sub Main()
FrmAudit.Show
End Sub

Sub Load_File_In_Mem(Name As String, Mem_Offset As Long, Optional LOB As Long = 0)
Dim ln As Long
Dim hFile As Integer

hFile = FreeFile
On Error GoTo exit_sub
     Open Name For Binary Access Read Lock Read As #hFile
         ln = LOF(hFile)
         ReDim buffer(0 To ln - 1) As Byte
         Get #hFile, , buffer
    Close #hFile
    
'   CopyMemory mem(Mem_Offset), NewBuffer(0), IIf(LOB <> 0, LOB, ln)
    
    Exit Sub
exit_sub:

    Close #hFile
End Sub

'Get CRC from file.
Public Function Get_CRC32(File_Name As String) As Long


  Dim cStream As New cBinaryFileStream
   cStream.File = File_Name
   
   Dim cCRC32 As New cCRC32
   Dim lCRC32 As Long

   lCRC32 = cCRC32.GetFileCrc32(cStream)
   
   Get_CRC32 = lCRC32

End Function

'Get CRC from array.
Public Function Get_CRC32_ARR(Byte_ArrAy() As Byte) As Long

   Dim cCRC32 As New cCRC32
   Dim lCRC32 As Long

   lCRC32 = cCRC32.GetByteArrayCrc32(Byte_ArrAy())
   
   Get_CRC32_ARR = lCRC32

End Function




Public Function Getw(addr As Long) As Long
If addr >= UBound(buffer) Then Getw = 0: Exit Function
    Getw = buffer(addr) Or (buffer((addr + 1)) * 256&)
End Function
' Retrive name in a long file name string ( "c:\vb\tmp\file.txt" -> "file.txt" )
Public Function Cut_Name(ByRef Ln_file As String) As String
Dim LastSlash, Scan_BS As Integer
Dim char_path As String * 1
Dim lng_file As String
lng_file = Ln_file
Ln_file = GetLongPathName(Ln_file)

' GetLongPathName can be corrupt! (return nul char.)
If Ln_file = "" Then Ln_file = lng_file
If InStr(Ln_file, "\") = 0 Then Cut_Name = Ln_file: Exit Function
   
    Scan_BS = Len(Ln_file)
    Do While InStr(1, Mid(Ln_file, Scan_BS, 1), "\", vbBinaryCompare) = 0
     Scan_BS = Scan_BS - 1
    Loop
 
Cut_Name = Trim(Right(Ln_file, Len(Ln_file) - Scan_BS))

End Function
Public Function GetLongPathName(Shortpath As String) As String
   Dim s As String
   Dim i As Long
   
   i = 255
   s = String(i, 0)
   GetLongPathNameA Shortpath, s, i
   
   GetLongPathName = Left$(s, InStr(s, Chr$(0)) - 1)
End Function
Public Function FileExists(Filename As String) As Boolean
If Filename = "" Then FileExists = False: Exit Function
Dim long_file As String
long_file = Filename 'GetLongPathName(FileName)

    On Error GoTo errhandle

' If GetAttr(FileName) And vbDirectory =16 -> directory name !
    If (GetAttr(Filename) And vbDirectory) = vbDirectory Then
            FileExists = True: Exit Function
    Else
' If filename !
    If Dir(long_file) = Cut_Name(Filename) Then FileExists = True: Exit Function
    If Dir(long_file) <> "" Then FileExists = True Else FileExists = False
End If
errhandle:
FileExists = False
End Function

Public Function App_Path() As String
' Fixe short to long directory name in VB.
App_Path = GetLongPathName(App.path)
End Function

Public Function CRC_LEN(CRC As String) As String
Dim a As Byte
CRC = Trim(CRC)
CRC_LEN = CRC
For a = Len(CRC) To 7
CRC_LEN = "0" + CRC_LEN
Next
End Function



