Attribute VB_Name = "ModZX81Fnc"

'//
'// Convert a ZX81 Character to a PC ASCII string value.
'//
Public Function ZXCharToASCII(ByVal cZX As Byte, Optional Func As Boolean = True) As String
    
    If (cZX And 64) = 64 Then ZXCharToASCII = "_": Exit Function
    
    cZX = cZX And 63
    
    Select Case cZX
    Case 0 ' // SPACE
        ZXCharToASCII = " "
    Case 11 To 13
        ' 11 = 34   "
        ' 12 = 35  /#
        ' 13 = 36  $
        ZXCharToASCII = Chr$(cZX + 23)
    Case 14
        ' 14 = :
        ZXCharToASCII = ":"
    Case 15
        ' 15 = ?
        ZXCharToASCII = "?"
    Case 16
        ' 16 = (
        ZXCharToASCII = "("
    Case 17
        ' 17 = )
        ZXCharToASCII = ")"
    Case 18
        ' 18 = >
        ZXCharToASCII = ">"
    Case 19
        ' 19 = <
        ZXCharToASCII = "<"
    Case 20
        ' 20 = =
        ZXCharToASCII = "="
    Case 21
        ' 21 = +
        ZXCharToASCII = "+"
    Case 22
        ' 22 = -
        ZXCharToASCII = "-"
    Case 23
        ' 23 = *
        ZXCharToASCII = "*"
    Case 24
        ' 24 = /
        ZXCharToASCII = "/"
    Case 25
        ' 25 = ;
        ZXCharToASCII = ";"
    Case 26
         ' 26 = ,
        ZXCharToASCII = ","
    Case 27
        ' 27 = .
        ZXCharToASCII = "."
    Case 28 To 37
        ZXCharToASCII = Chr$(cZX + 20)
    Case 38 To 63
        ZXCharToASCII = Chr$(cZX + 27)
    Case 118 And Func
        ZXCharToASCII = "N/L" 'vbCrLf
    Case Else
        ZXCharToASCII = "_"
    End Select
End Function

'//
'// Get the real ZX81 NAME:
'// Search the SAVE"xxx" line in the Basic programme and return the name.

Function GetMemName(File_Name As String) As String
'// Load P File.
Dim ln As Long
Dim hFile As Integer
Dim CRC32 As String
Dim buffer2() As Byte
Dim D_File As Long
Dim Bas_Start As Long

If Not FileExists(File_Name) Then Exit Function

hFile = FreeFile
On Error GoTo exit_sub
 Open File_Name For Binary Access Read Lock Read As #hFile

         ln = LOF(hFile)
         If ln = 0 Or ln > 65536 Then GoTo exit_sub
         ReDim buffer(0 To ln - 1) As Byte
         Get #hFile, , buffer
         
 Close #hFile
 

 D_File = Getw(3) - &H4009 ' Offset 400Ch
 If D_File > 65536 Or D_File < 0 Or D_File > ln Then GoTo exit_sub
 
 'Retrieve then Basic CRC.
 Bas_Start = 122 ' Offset 40D7h
 If D_File - Bas_Start < 0 Then GoTo exit_sub
 ReDim buffer2(0 To D_File - Bas_Start) As Byte
  CopyMemory buffer2(0), buffer(122), D_File - Bas_Start + 1
  
  
CRC32 = Hex(Get_CRC32_ARR(buffer2))
If Len(CRC32) < 8 Then
CRC32 = CRC_LEN(CRC32)
End If
FrmAudit!File_List.ListItems.Item(FrmAudit!File_List.ListItems.count).SubItems(4) = CRC32

 
' ??? Yu've got an Apple directory name on your hard disk ???
If InStr(1, File_Name, ".", vbBinaryCompare) = 0 Then File_Name = File_Name + ".###"

Dim Sca_off As Long
Dim Str_Tmp As String
Dim Cnt As Long

'Get Next_Line Offset
Sca_off = Getw(&H20) - &H4007
If Sca_off >= ln Then GoTo exit_sub
'
'Scan the basic program to find the SAVE"" name.
'using the auto-loder (NXT-LINE) pointer.

If Sca_off > 2 Then
   'Find the Ret char. code &h76 to locate the start address.
   Do While Sca_off > 0
     If buffer(Sca_off) = &H76 Or Sca_off = &H73 Then Exit Do Else Sca_off = Sca_off - 1
   Loop
   'Ok ... &hF8=SAVE basic function. &h62=Anything.
   On Error GoTo 0
        If buffer(Sca_off + 5) = &HF8 Or buffer(Sca_off + 5) = &H62 Then
        
        '// Saved With a variable! (the Name is in the vars ... Bhaaa! Basta...)
        If buffer(Sca_off + 6) <> &HB Then
        GetMemName = Left(UCase(Cut_Name(File_Name)), InStr(1, Cut_Name(File_Name), ".", vbBinaryCompare) - 1)
        Exit Function
        '// Unlucky ...
        End If
        
        ' Get name string...
        Str_Tmp = ""
        For a = Sca_off + 7 To Getw(&H20) - &H4006
        Str_Tmp = Str_Tmp + ZXCharToASCII(buffer(a))
        Next
        
        If Str_Tmp = "" Or Len(Str_Tmp) > 25 Then GoTo Force_Scan
        
        'Cut and retieve the ZX file name.
        GetMemName = Str_Tmp ' & ".P"
        
        ' Haaarg! A SAVE"SAVE:P:NAME:" from Xtender ... later versions!
        ' MAGIC couic , couic ...
        If buffer(Sca_off + 5) = &H62 Then
        GetMemName = Right(Str_Tmp, Len(Str_Tmp) - (InStr(1, Str_Tmp, "P") + 1))
        GetMemName = Left(GetMemName, Len(GetMemName) - 1) ' & ".P"
        ' Tadaaaa !
        ' Thanks every body! Thanks!
        End If
        
        Exit Function
        End If
        
End If

Force_Scan:

'
' Now try to Scan the old Xtender backup (available in ROM address):
' Print rand usr 8192;"Save:p:..."
'
For Sca_off = &H73 To UBound(buffer) - 12
If buffer(Sca_off) = &H38 And buffer(Sca_off + 1) = &H26 And _
buffer(Sca_off + 2) = &H3B And buffer(Sca_off + 5) = &H35 Then Exit For
Next

If Sca_off = UBound(buffer) - 11 Then GoTo Force_Scan2

Str_Tmp = ""
Sca_off = Sca_off + 7
If Sca_off >= UBound(buffer) Then Exit Function
Do While buffer(Sca_off) <> &HB
Str_Tmp = Str_Tmp + ZXCharToASCII(buffer(Sca_off))
If Sca_off = ln - 1 Then Exit Do
Sca_off = Sca_off + 1
Loop

GetMemName = Left(Str_Tmp, Len(Str_Tmp) - 1) ' + ".P"
Exit Function

Force_Scan2:

' //
' // Force Basic Reading.
' //

'Deep Scan NXT_Line = D_file (Saved under basic Prompt).
'a Save"GAME" exist in the back-up ... Somewhere...
'It will scan all of this (@!$$$##&)  file!

If GetMemName = "" Then
For Sca_off = &H73 To UBound(buffer) - 6
If buffer(Sca_off) = 0 And buffer(Sca_off + 1) = &HF8 And buffer(Sca_off + 2) = &HB Then Exit For
Next
If Sca_off = UBound(buffer) + 5 Then GoTo Force_Scan3
Str_Tmp = ""
Sca_off = Sca_off + 3

Do While buffer(Sca_off) <> &HB
Str_Tmp = Str_Tmp + ZXCharToASCII(buffer(Sca_off))
If Sca_off = ln - 1 Then Exit Do
Sca_off = Sca_off + 1
Loop

    If Str_Tmp <> "" And Len(Str_Tmp) < 25 And InStr(1, Str_Tmp, "_") = 0 Then
    GetMemName = Str_Tmp ' + ".P"
    Exit Function
    End If
End If

Force_Scan3:
Str_Tmp = ""

'Last TesT...
'The name is in the printer buffer??? (old emulators)
GetMemName = ""
For a = &H36 To &H52
GetMemName = GetMemName + ZXCharToASCII(buffer(a))
Next
GetMemName = Trim(GetMemName)

' Nothing ... "SUPER MEGA COMBO HIT of the death! You Loose!" ... Nada!

If InStr(1, GetMemName, "_") > 0 Or GetMemName = "" Then
GetMemName = Left(UCase(Cut_Name(File_Name)), InStr(1, Cut_Name(File_Name), ".", vbBinaryCompare) - 1)
End If


ReDim buffer(0)
'end select
Exit Function

exit_sub:
Close #hFile
End Function
